/****************************************************************************************
	MrMacintosh.cp
	
	Copyright  2001 Red Shed Software. All rights reserved.
	by Jonathan 'Wolf' Rentzsch (jon@redshed.net)
	
	Commenter	Date				Comment
	---------	-----------------	-----------------------------------------------------
	wolf		Fri, Jun 22, 2001	Created.
	
	************************************************************************************/

#include	"MrMacintosh.h"
#include	"require.h"
#include	"QuitMessages.h"
#include	"Flour.h"
#include	"jGNE.h"
#include	"MenuList.h"
#include	"XErr.h"
//#include	"TextServices.h"

#define		RectHeight( originalRect )	((originalRect).bottom - (originalRect).top)
#define		RectWidth( r )				((r).right - (r).left)

using namespace Flour;

/**************************
*	
*	Classes
*	
**************************/
#pragma mark	(Classes)

class	MyApp : public Application {
	public:
			virtual
			void
		Initialize();
		
			virtual
			void
		ShutDown();
		
			virtual
			void
		HandleMenuSelection(
			Event	&event );
};

MyApp		gMyApp;
Application	*gApp = &gMyApp;

	pascal
	void
MyEventFilter(
	EventRecord	*theEvent,
	Boolean		*result );

void	ShowMrMacintosh();
void	ShowMrMacintosh2();

const	UInt32	kHideUntil	=	4;
UInt32	gCount = kHideUntil;

PicHandle	gUno = nil, gDos = nil, gTres = nil;
GWorldPtr	gNewWorld = nil, gNewWorld2 = nil;
PixMapHandle	gNewWorldPixMap = nil, gNewWorldPixMap2 = nil;
bool	gEven = true;

/****************************************************************************************
*	
*	Functions
*	
****************************************************************************************/
#pragma mark	-
#pragma mark	(Functions)

/****************************************************************************************
	Commenter	Date				Comment
	---------	-----------------	-----------------------------------------------------
	wolf		Mon, Mar 6, 2000	Created.
	
	************************************************************************************/

	void
MyApp::Initialize()
{
	Application::Initialize();
	
	//	Grab Picts.
	gUno = (PicHandle) Get1Resource( 'PICT', 128 );
	ThrowIfResFail( gUno );
	
	/*r = (**gPic).picFrame;
	OffsetRect( &r, -r.left, -r.top );*/
	
	gDos = (PicHandle) Get1Resource( 'PICT', 129 );
	ThrowIfResFail( gDos );
	
	gTres = (PicHandle) Get1Resource( 'PICT', 130 );
	ThrowIfResFail( gTres );
				
	//	Create offscreen GWorld buffer.
	Rect			originalRect = (**gUno).picFrame;
	GDHandle		mainDevice = GetMainDevice();
	PixMapHandle	mainDevicePixMap = (**mainDevice).gdPMap;
	short			pixDepth = (**mainDevicePixMap).pixelSize;
	
	GWorldPtr		gNewWorld;
					ThrowIfErr( NewGWorld( &gNewWorld, pixDepth, &originalRect, nil, nil, 0 ));
	gNewWorldPixMap = GetGWorldPixMap( gNewWorld );
				
	//	Create offscreen GWorld buffer #2.
	Rect			originalRect2 = (**gUno).picFrame;
	
	GWorldPtr		gNewWorld2;
					ThrowIfErr( NewGWorld( &gNewWorld2, pixDepth, &originalRect2, nil, nil, 0 ));
	gNewWorldPixMap2 = GetGWorldPixMap( gNewWorld2 );
	
	//ShowMrMacintosh2();
	
	//	Install the filter.
	ThrowIfErr( InstalljGNE( NewGetNextEventFilterUPP( MyEventFilter ) ) );
	//gDoubt << "uno = " << gUno << doubt::stop;
	

#if	0
	WindowPtr	w = nil;
	ThrowIfErr( NewCServiceWindow( nil, &originalRect, "\p", false,
		kPlainDialogVariantCode, kFirstWindowOfClass, false,
		(ComponentInstance) kCurrentProcess, &w ) );
	
	//((WindowPeek) w)->windowPic = gUno;
	
	{
		short	startHeight = GetMBarHeight() - RectHeight( originalRect );
		short	endHeight = GetMBarHeight();
		short	slideDelta = endHeight - startHeight;
		short	slideIncrement = slideDelta / 30;
		UInt32	ignored;
		EventRecord	ignored2;
		
		MoveWindow( w, 0, startHeight, false );
		SetPort( w );
		ShowWindow( w );
		
		for( short currentV = startHeight; currentV < endHeight; currentV += slideIncrement ) {
			MoveWindow( w, 0, currentV, false );
			
			Delay( 1, &ignored );
			DrawPicture( gUno, &originalRect );
			//WaitNextEvent( everyEvent, &ignored2, 1, nil );
		}
	}
	
	CloseServiceWindow( w );
#endif
}

/****************************************************************************************
	Commenter	Date				Comment
	---------	-----------------	-----------------------------------------------------
	wolf		Mon, Mar 6, 2000	Created.
	
	************************************************************************************/

	void
MyApp::ShutDown()
{
	ThrowIfErr( RemovejGNE() );
	DisposeGWorld( gNewWorld );
	//gDoubt << "uno = " << gUno << doubt::stop;
}

/****************************************************************************************
	Commenter	Date				Comment
	---------	-----------------	-----------------------------------------------------
	wolf		Mon, Mar 6, 2000	Created.
	
	************************************************************************************/

	void
MyApp::HandleMenuSelection(
	Event	&event )
{
	switch( event.GetMenu() ) {
		case kAppleMenu:
			switch( event.GetMenuItem() ) {
				case kAboutItem:
					Debugger();
					break;
				default:
					HandleAppleMenuSelection( event );
			}
			break;
		case kFileMenu:
			switch( event.GetMenuItem() ) {
				case kQuitItem:
					BeginQuitting();
					break;
				default:
					RequireSwitch( event.GetMenuItem() );
			}
			break;
		//	The frontmost window should have handled all Edit menu events.
		//case kEditMenu:
		//	break;
		default:
			RequireSwitch( event.GetMenu() );
	}
}

/****************************************************************************************
	Commenter	Date				Comment
	---------	-----------------	-----------------------------------------------------
	wolf		Fri, Jun 22, 2001	Created.
	
	************************************************************************************/

	pascal
	void
MyEventFilter(
	EventRecord	*event,
	Boolean		*result )
{
	//gDoubt << "uno = " << gUno << doubt::stop;
	if( event->what == mouseDown ) {
		Point			mouse;
						GetMouse( &mouse );
		
		if( mouse.v <= GetMBarHeight() && --gCount == 0 ) {
			SysBeep( 20 );
			
			/*HiliteMenu( 128 );
			Delay( 60, &ignored );
			HiliteMenu( 0 );*/
			if( gEven )
				ShowMrMacintosh2();
			else
				ShowMrMacintosh();
			gEven = !gEven;
			
			*result = false;
			gCount = kHideUntil;
		}
	}
	
	GetNextEventFilterUPP	next = GetNextjGNE();
	if( next )
		CallGetNextEventFilterProc( next, event, result );
}

/****************************************************************************************
	Commenter	Date				Comment
	---------	-----------------	-----------------------------------------------------
	wolf		Fri, Jun 22, 2001	Created.
	
	************************************************************************************/

	void
ShowMrMacintosh()
{
	//	Setup dimensions.
	Rect		originalRect = (**gUno).picFrame;
				OffsetRect( &originalRect, -originalRect.left, -originalRect.top );
	short		startV = GetMBarHeight();
	short		endV = startV + RectHeight( originalRect );
	short		incrementV = (endV - startV) / 10;
	
	Point		mouse;
				GetMouse( &mouse );
	
	Rect		finalDeskRect = originalRect;
				finalDeskRect.top = GetMBarHeight();
				finalDeskRect.bottom = finalDeskRect.top + RectHeight( originalRect );
				finalDeskRect.left = mouse.h;
				finalDeskRect.right = finalDeskRect.left + RectWidth( originalRect );
	
	//	Copy Original Screen into buffer.
	GDHandle		mainDevice = GetMainDevice();
	HLock( (Handle) mainDevice );
	PixMapHandle	mainDevicePixMap = (**mainDevice).gdPMap;
	//PixMapHandle	newWorldPixMap = GetGWorldPixMap( gNewWorld );
	
	HLock( (Handle) mainDevicePixMap );
	HLock( (Handle) gNewWorldPixMap );
	LockPixels( mainDevicePixMap );
	LockPixels( gNewWorldPixMap );
	
	CopyBits( (BitMap*) *mainDevicePixMap, (BitMap*) *gNewWorldPixMap, &finalDeskRect, &originalRect, srcCopy, nil );
	
	//	Get the Window Manager.
	WindowPtr	w = LMGetWMgrPort();
	SetPort( w );
	
	//	Slide window into view.
	Rect		transformRect = finalDeskRect;
	UInt32		ignored;
	for( short currentV = startV; currentV <= endV; currentV += incrementV ) {
		transformRect.bottom = currentV;
		DrawPicture( gUno, &transformRect );
		Delay( 1, &ignored );
	}
	
	//	Animate.
	for( short frameCount = 3; frameCount != 0; frameCount-- ) {
		DrawPicture( gDos, &transformRect );
		Delay( 1, &ignored );
		DrawPicture( gUno, &transformRect );
	}
	
	//	Slide window from view.
	Rect	restoreRect = finalDeskRect;
	for( short currentV = endV; currentV >= startV; currentV -= incrementV ) {
		restoreRect.top = transformRect.bottom = currentV;
		CopyBits( (BitMap*) *gNewWorldPixMap, (BitMap*) *mainDevicePixMap, &originalRect, &restoreRect, srcCopy, nil );
		DrawPicture( gUno, &transformRect );
		Delay( 1, &ignored );
	}
	CopyBits( (BitMap*) *gNewWorldPixMap, (BitMap*) *mainDevicePixMap, &originalRect, &finalDeskRect, srcCopy, nil );
	
	UnlockPixels( mainDevicePixMap );
	UnlockPixels( gNewWorldPixMap );
	HUnlock( (Handle) mainDevicePixMap );
	HUnlock( (Handle) gNewWorldPixMap );
}

/****************************************************************************************
	Commenter	Date				Comment
	---------	-----------------	-----------------------------------------------------
	wolf		Fri, Jun 22, 2001	Created.
	
	************************************************************************************/

	void
ShowMrMacintosh2()
{
	//	Setup dimensions.
	Rect		originalRect = (**gTres).picFrame;
				OffsetRect( &originalRect, -originalRect.left, -originalRect.top );
	short		startV = GetMBarHeight();
	short		endV = startV + RectHeight( originalRect );
	short		incrementV = (endV - startV) / 15;
	
	Point		mouse;
				GetMouse( &mouse );
	
	Rect		finalDeskRect = originalRect;
				finalDeskRect.top = GetMBarHeight();
				finalDeskRect.bottom = finalDeskRect.top + RectHeight( originalRect );
				finalDeskRect.left = mouse.h;
				finalDeskRect.right = finalDeskRect.left + RectWidth( originalRect );
	
	//	Copy Original Screen into buffer.
	GDHandle		mainDevice = GetMainDevice();
	HLock( (Handle) mainDevice );
	PixMapHandle	mainDevicePixMap = (**mainDevice).gdPMap;
	//PixMapHandle	newWorldPixMap2 = GetGWorldPixMap( gNewWorld );
	
	HLock( (Handle) mainDevicePixMap );
	HLock( (Handle) gNewWorldPixMap2 );
	LockPixels( mainDevicePixMap );
	LockPixels( gNewWorldPixMap2 );
	
	CopyBits( (BitMap*) *mainDevicePixMap, (BitMap*) *gNewWorldPixMap2, &finalDeskRect, &originalRect, srcCopy, nil );
	
	//	Get the Window Manager.
	WindowPtr	w = LMGetWMgrPort();
	SetPort( w );
	
	//	Slide window into view.
	Rect		transformRect = finalDeskRect;
	UInt32		ignored;
	for( short currentV = startV; currentV <= endV; currentV += incrementV ) {
		transformRect.bottom = currentV;
		DrawPicture( gTres, &transformRect );
		Delay( 1, &ignored );
	}
	
	Delay( 15, &ignored );
	
	//	Slide window from view.
	Rect	restoreRect = finalDeskRect;
	for( short currentV = endV; currentV >= startV; currentV -= incrementV ) {
		restoreRect.top = transformRect.bottom = currentV;
		DrawPicture( gTres, &transformRect );
		CopyBits( (BitMap*) *gNewWorldPixMap2, (BitMap*) *mainDevicePixMap, &originalRect, &restoreRect, srcCopy, nil );
		Delay( 1, &ignored );
	}
	CopyBits( (BitMap*) *gNewWorldPixMap2, (BitMap*) *mainDevicePixMap, &originalRect, &finalDeskRect, srcCopy, nil );
	
	UnlockPixels( mainDevicePixMap );
	UnlockPixels( gNewWorldPixMap2 );
	HUnlock( (Handle) mainDevicePixMap );
	HUnlock( (Handle) gNewWorldPixMap2 );
}